# Mumble-Notifier

XMPP bot which notifies a MUC of newly joined Mumble users.

## Setup

Firstly, make sure the bot can access your Mumble server's log file.

Either set the necessary environment variables at runtime, or put them in a `.env` file in this directory:

```
MUMBLE_BOT_JID=mumble-bot@linux.ucla.edu
MUMBLE_BOT_PASSWORD=hunter2
MUMBLE_BOT_MUC=main@room.linux.ucla.edu
MUMBLE_BOT_MURMUR_LOG=/var/log/mumble-server/mumble-server.log
MUMBLE_BOT_MUMBLE_URL="mumble://linux.ucla.edu"
```

Install dependencies and run the project in a virtual environment like so:

```sh
python3 -m venv venv
source venv/bin/activate
pip install -r requirements.txt
python3 bot.py
```

You will probably want to change `templates.py` to use a suitable notification message(s) for your own group.

## Dependencies

* slixmpp
* python-dotenv
